> For clean Markdown of any page, append .md to the page URL.
> For a complete documentation index, see https://help.sigmacomputing.com/llms.txt.
> For AI client integration (Claude Code, Cursor, etc.), connect to the MCP server at https://help.sigmacomputing.com/_mcp/server.

# Create an embed for a workbook

POST https://api.sigmacomputing.com/v2/workbooks/{workbookId}/embeds
Content-Type: application/json

This endpoint lets you create an embed for a specific workbook. You can embed an entire workbook, a specific page, or an individual element within a workbook. Embedding enables seamless integration of Sigma content into other applications, websites, or internal platforms, providing a flexible and dynamic way to present and interact with data.

### Embedding options

- Publicly embed Sigma in a public website by creating an embed of type `public`.
- Securely embed Sigma in an authenticated host application.

  - (Recommended) Use JSON Web Tokens (JWT) to sign the workbook URL outputted by the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint instead of the output of this endpoint. See [Create a secure embed](/docs/create-a-secure-embed).
  - (Deprecated) Use this endpoint to create an embed of type `secure`. This option is deprecated. See [Migrate to JWT-signed secure embed URLs](/docs/migrate-to-jwt-signed-secure-embed-urls).

### Usage notes
- The endpoint requires the workbookId as a path parameter. Retrieve the **workbookId** by calling the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint.
- The body of the request must specify the type of embed (public).
- You must specify the source type (workbook, page, element) and ID for that source to create the embed.

  - Retrieve the **pageId** by calling the [/v2/workbooks/{workbookId}/pages](https://help.sigmacomputing.com/reference/list-workbook-pages) endpoint.
  - Retrieve the **elementId** by first calling the [/v2/workbooks/{workbookId}/pages](https://help.sigmacomputing.com/reference/list-workbook-pages) endpoint, then calling the [/v2/workbooks/{workbookId}/pages/{pageId}/elements](https://help.sigmacomputing.com/reference/list-workbook-page-elements) endpoint.

### Usage scenarios
- **Web application integration:** Developers can use this API to generate the embed URL for integration into their application or for display on a public-facing webpage.

### Best practices
- Validate the `workbookId` and `sourceId` to ensure they refer to existing resources before attempting to create an embed.
- Consider the security settings of the embed type to match the integration context, ensuring that data exposure is controlled and appropriate for the audience.

Reference: https://help.sigmacomputing.com/reference/create-workbook-embed

## OpenAPI Specification

```yaml
openapi: 3.1.0
info:
  title: sigma-rest-api
  version: 1.0.0
paths:
  /v2/workbooks/{workbookId}/embeds:
    post:
      operationId: createWorkbookEmbed
      summary: Create an embed for a workbook
      description: >-
        This endpoint lets you create an embed for a specific workbook. You can
        embed an entire workbook, a specific page, or an individual element
        within a workbook. Embedding enables seamless integration of Sigma
        content into other applications, websites, or internal platforms,
        providing a flexible and dynamic way to present and interact with data.


        ### Embedding options


        - Publicly embed Sigma in a public website by creating an embed of type
        `public`.

        - Securely embed Sigma in an authenticated host application.

          - (Recommended) Use JSON Web Tokens (JWT) to sign the workbook URL outputted by the [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks) endpoint instead of the output of this endpoint. See [Create a secure embed](/docs/create-a-secure-embed).
          - (Deprecated) Use this endpoint to create an embed of type `secure`. This option is deprecated. See [Migrate to JWT-signed secure embed URLs](/docs/migrate-to-jwt-signed-secure-embed-urls).

        ### Usage notes

        - The endpoint requires the workbookId as a path parameter. Retrieve the
        **workbookId** by calling the
        [/v2/workbooks](https://help.sigmacomputing.com/reference/list-workbooks)
        endpoint.

        - The body of the request must specify the type of embed (public).

        - You must specify the source type (workbook, page, element) and ID for
        that source to create the embed.

          - Retrieve the **pageId** by calling the [/v2/workbooks/{workbookId}/pages](https://help.sigmacomputing.com/reference/list-workbook-pages) endpoint.
          - Retrieve the **elementId** by first calling the [/v2/workbooks/{workbookId}/pages](https://help.sigmacomputing.com/reference/list-workbook-pages) endpoint, then calling the [/v2/workbooks/{workbookId}/pages/{pageId}/elements](https://help.sigmacomputing.com/reference/list-workbook-page-elements) endpoint.

        ### Usage scenarios

        - **Web application integration:** Developers can use this API to
        generate the embed URL for integration into their application or for
        display on a public-facing webpage.


        ### Best practices

        - Validate the `workbookId` and `sourceId` to ensure they refer to
        existing resources before attempting to create an embed.

        - Consider the security settings of the embed type to match the
        integration context, ensuring that data exposure is controlled and
        appropriate for the audience.
      tags:
        - Workbooks
      parameters:
        - name: workbookId
          in: path
          required: true
          schema:
            type: string
        - name: Authorization
          in: header
          description: OAuth authentication
          required: true
          schema:
            type: string
      responses:
        '200':
          description: The response body.
          content:
            application/json:
              schema:
                $ref: >-
                  #/components/schemas/workbooks_createWorkbookEmbed_Response_200
      requestBody:
        description: The request body.
        content:
          application/json:
            schema:
              type: object
              properties:
                embedType:
                  $ref: >-
                    #/components/schemas/V2WorkbooksWorkbookIdEmbedsPostRequestBodyContentApplicationJsonSchemaEmbedType
                  description: >-
                    Defines the visibility and access control of the embed.
                    Choose `public` for open access or `secure` for restricted
                    access. The `secure` and `application` options are both
                    deprecated.
                sourceType:
                  $ref: >-
                    #/components/schemas/V2WorkbooksWorkbookIdEmbedsPostRequestBodyContentApplicationJsonSchemaSourceType
                  description: >-
                    Specifies the scope of the embed: "workbook" for the entire
                    workbook, "page" for a single page, or "element" for a
                    specific element within the workbook.
                sourceId:
                  type: string
                  description: >-
                    The specific identifier for the page or element to be
                    embedded if the sourceType is "page" or "element".
              required:
                - embedType
                - sourceType
servers:
  - url: https://api.sigmacomputing.com
    description: Server for GCP (US) hosted organizations
  - url: https://api.sa.gcp.sigmacomputing.com
    description: Server for GCP (KSA) hosted organizations
  - url: https://aws-api.sigmacomputing.com
    description: Server for AWS US (West) hosted organizations
  - url: https://api.us-a.aws.sigmacomputing.com
    description: Server for AWS US (East) hosted organizations
  - url: https://api.ca.aws.sigmacomputing.com
    description: Server for AWS Canada hosted organizations
  - url: https://api.eu.aws.sigmacomputing.com
    description: Server for AWS Europe hosted organizations
  - url: https://api.au.aws.sigmacomputing.com
    description: Server for AWS Australia and APAC hosted organizations
  - url: https://api.uk.aws.sigmacomputing.com
    description: Server for AWS UK hosted organizations
  - url: https://api.us.azure.sigmacomputing.com
    description: Server for Azure US hosted organizations
  - url: https://api.eu.azure.sigmacomputing.com
    description: Server for Azure Europe hosted organizations
  - url: https://api.ca.azure.sigmacomputing.com
    description: Server for Azure Canada hosted organizations
  - url: https://api.uk.azure.sigmacomputing.com
    description: Server for Azure United Kingdom hosted organizations
  - url: https://api.au.azure.sigmacomputing.com
    description: Server for Azure Australia hosted organizations
components:
  schemas:
    V2WorkbooksWorkbookIdEmbedsPostRequestBodyContentApplicationJsonSchemaEmbedType:
      type: string
      enum:
        - secure
        - public
        - application
      description: >-
        Defines the visibility and access control of the embed. Choose `public`
        for open access or `secure` for restricted access. The `secure` and
        `application` options are both deprecated.
      title: >-
        V2WorkbooksWorkbookIdEmbedsPostRequestBodyContentApplicationJsonSchemaEmbedType
    V2WorkbooksWorkbookIdEmbedsPostRequestBodyContentApplicationJsonSchemaSourceType:
      type: string
      enum:
        - workbook
        - page
        - element
      description: >-
        Specifies the scope of the embed: "workbook" for the entire workbook,
        "page" for a single page, or "element" for a specific element within the
        workbook.
      title: >-
        V2WorkbooksWorkbookIdEmbedsPostRequestBodyContentApplicationJsonSchemaSourceType
    workbooks_createWorkbookEmbed_Response_200:
      type: object
      properties:
        embedId:
          type: string
          description: Unique identifier of the embed.
        embedUrl:
          type: string
      required:
        - embedId
        - embedUrl
      title: workbooks_createWorkbookEmbed_Response_200
  securitySchemes:
    OAuth:
      type: http
      scheme: bearer
      description: OAuth 2.0 authentication

```

## Examples



**Request**

```json
{
  "embedType": "public",
  "sourceType": "workbook"
}
```

**Response**

```json
{
  "embedId": "a1b2c3d4-e5f6-7890-ab12-cd34ef567890",
  "embedUrl": "https://embed.sigmacomputing.com/workbooks/a1b2c3d4-e5f6-7890-ab12-cd34ef567890?embedType=public"
}
```

**SDK Code**

```python
import requests

url = "https://api.sigmacomputing.com/v2/workbooks/workbookId/embeds"

payload = {
    "embedType": "public",
    "sourceType": "workbook"
}
headers = {
    "Authorization": "<token>.",
    "Content-Type": "application/json"
}

response = requests.post(url, json=payload, headers=headers)

print(response.json())
```

```javascript
const url = 'https://api.sigmacomputing.com/v2/workbooks/workbookId/embeds';
const options = {
  method: 'POST',
  headers: {Authorization: '<token>.', 'Content-Type': 'application/json'},
  body: '{"embedType":"public","sourceType":"workbook"}'
};

try {
  const response = await fetch(url, options);
  const data = await response.json();
  console.log(data);
} catch (error) {
  console.error(error);
}
```

```go
package main

import (
	"fmt"
	"strings"
	"net/http"
	"io"
)

func main() {

	url := "https://api.sigmacomputing.com/v2/workbooks/workbookId/embeds"

	payload := strings.NewReader("{\n  \"embedType\": \"public\",\n  \"sourceType\": \"workbook\"\n}")

	req, _ := http.NewRequest("POST", url, payload)

	req.Header.Add("Authorization", "<token>.")
	req.Header.Add("Content-Type", "application/json")

	res, _ := http.DefaultClient.Do(req)

	defer res.Body.Close()
	body, _ := io.ReadAll(res.Body)

	fmt.Println(res)
	fmt.Println(string(body))

}
```

```ruby
require 'uri'
require 'net/http'

url = URI("https://api.sigmacomputing.com/v2/workbooks/workbookId/embeds")

http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true

request = Net::HTTP::Post.new(url)
request["Authorization"] = '<token>.'
request["Content-Type"] = 'application/json'
request.body = "{\n  \"embedType\": \"public\",\n  \"sourceType\": \"workbook\"\n}"

response = http.request(request)
puts response.read_body
```

```java
import com.mashape.unirest.http.HttpResponse;
import com.mashape.unirest.http.Unirest;

HttpResponse<String> response = Unirest.post("https://api.sigmacomputing.com/v2/workbooks/workbookId/embeds")
  .header("Authorization", "<token>.")
  .header("Content-Type", "application/json")
  .body("{\n  \"embedType\": \"public\",\n  \"sourceType\": \"workbook\"\n}")
  .asString();
```

```php
<?php
require_once('vendor/autoload.php');

$client = new \GuzzleHttp\Client();

$response = $client->request('POST', 'https://api.sigmacomputing.com/v2/workbooks/workbookId/embeds', [
  'body' => '{
  "embedType": "public",
  "sourceType": "workbook"
}',
  'headers' => [
    'Authorization' => '<token>.',
    'Content-Type' => 'application/json',
  ],
]);

echo $response->getBody();
```

```csharp
using RestSharp;

var client = new RestClient("https://api.sigmacomputing.com/v2/workbooks/workbookId/embeds");
var request = new RestRequest(Method.POST);
request.AddHeader("Authorization", "<token>.");
request.AddHeader("Content-Type", "application/json");
request.AddParameter("application/json", "{\n  \"embedType\": \"public\",\n  \"sourceType\": \"workbook\"\n}", ParameterType.RequestBody);
IRestResponse response = client.Execute(request);
```

```swift
import Foundation

let headers = [
  "Authorization": "<token>.",
  "Content-Type": "application/json"
]
let parameters = [
  "embedType": "public",
  "sourceType": "workbook"
] as [String : Any]

let postData = JSONSerialization.data(withJSONObject: parameters, options: [])

let request = NSMutableURLRequest(url: NSURL(string: "https://api.sigmacomputing.com/v2/workbooks/workbookId/embeds")! as URL,
                                        cachePolicy: .useProtocolCachePolicy,
                                    timeoutInterval: 10.0)
request.httpMethod = "POST"
request.allHTTPHeaderFields = headers
request.httpBody = postData as Data

let session = URLSession.shared
let dataTask = session.dataTask(with: request as URLRequest, completionHandler: { (data, response, error) -> Void in
  if (error != nil) {
    print(error as Any)
  } else {
    let httpResponse = response as? HTTPURLResponse
    print(httpResponse)
  }
})

dataTask.resume()
```